#include <stdio.h>
#include <math.h>
double integral(double x1, double x2, long n, double (*f)(double))
{ long i;
  double s=0.0,x,dx;
  dx=(x2-x1)/n;
  for(i=0;i<n;i++)
  { x=x1+(x2-x1)*i/n;
    s+=f(x)+f(x+dx);
  }
  s*=dx/2.0;
  return s;
}
double sx,sy,ss,cx,cy,cr;
double sqf(double x)
{ double y1,y2;
  double dy;
  if(x<=cx-cr) return 0;
  if(x>=cx+cr) return 0;
  dy=sqrt(cr*cr-(x-cx)*(x-cx));
  y2=cy+dy;
  y1=cy-dy;
  if(y2<=sy) return 0;
  if(y1>=sy+ss) return 0;
  if(y2>sy+ss) y2=sy+ss;
  if(y1<sy) y1=sy;
  return y2-y1;
}
int main()
{
  FILE *f;
  f=fopen("input.txt","r");
  fscanf(f,"%lf%lf%lf%lf%lf%lf",
    &cx,&cy,&cr,&sx,&sy,&ss);
  fclose(f);
  f=fopen("output.txt","w");
  fprintf(f,"%.2lf\n",integral(sx,sx+ss,10000L,sqf));
  fclose(f);
  return 0;
}